/*
**	tHgt@C쐬vO  By K.Takapyu
**
**	  J3100,EPSON-PC,NEC-PC,FM-R,FM-TOWNSIɔʂA
**	  tHgt@C쐬B
*/
#include <stdio.h>
#include <dos.h>
#include <fcntl.h>
#include <sys\stat.h>
#include <io.h>
#include <mem.h>
#include <ctype.h>

#include "hiradata.h"

#define ON  1
#define OFF 0

#define ASCII	0
#define KANA	1
#define JIS_1	2
#define JIS_2	3


#define BUFFER_SIZE	4096
#define SECTION_SIZE	3008

#define TOSHIBA	0x0001
#define EPSON	0x0002
#define NEC		0x0004
#define PC98	(EPSON|NEC)
#define FMR		0x0008
#define TOWNS	0x0010
#define FUJITSU	(FMR|TOWNS)

char bs_data[] = 
{
	0x00 , 0x00 , 0x40 , 0x40 , 0x20 , 0x20 , 0x10 , 0x10 ,
	0x08 , 0x08 , 0x04 , 0x04 , 0x02 , 0x02 , 0x00 , 0x00
};

char jis_keisen[] = {
	0x24 , 0x26 , 0x30 , 0x34 , 0x3c , 0x38 , 0x40 , 0x50 ,
	0x48 , 0x58 , 0x60 , 0x25 , 0x27 , 0x33 , 0x37 , 0x3f ,
	0x3b , 0x47 , 0x57 , 0x4f , 0x5f , 0x6f , 0x44 , 0x53 ,
	0x4c , 0x5b , 0x63 , 0x41 , 0x54 , 0x49 , 0x5c , 0x66
};

struct {
	unsigned char control[2];
	unsigned char buffer[32];
} font;

int get_all_font(char *filename , int flag , int font_type);
int keisen(char *pt , int flag);
int get_ascii_font(int code , unsigned char *font , int flag);
int toshiba_get_ascii_font(unsigned char *font);
int get_kanji_font(int high , int low, unsigned char *font , int flag);
int search_strings(unsigned int seg , char *sch);
int far_strncmpi(char far *s1 , char far *s2 , int len);

int font_style;

main(int argc , char *argv[])
{
	char filename[80];
	char name[80];
	int flag = 0;
	int font_type = JIS_2;
	int i;

	name[0] = '\0';
	font_style = 0;
	puts("tHgt@C쐬  Ver 0.6  By K.Takapyu");
	for(i = 1 ; i < argc ; i++) {
		if(argv[i][0] == '-') {
			switch(argv[i][1]) {
				case 'j':
				case 'J':
					strcpy(filename , "J3100.FON");
					flag = TOSHIBA;
					break;
				case 'n':
				case 'N':
					strcpy(filename , "PC98.FON");
					flag = NEC;
					break;
				case 'f':
				case 'F':
					strcpy(filename , "FMR.FON");
					flag = FMR;
					break;
				case '1':
					font_type = JIS_1;
					break;
				case 'a':
				case 'A':
					font_type = ASCII;
					break;
				case 'h':
				case 'H':
					font_type = KANA;
					break;
				case 's':
				case 'S':
					if(isdigit(argv[i][2])) {
						font_style = (argv[i][2] - '0');
					}
					break;
				case '?':
					usage();
					exit(0);
				default:
					puts("IvVׂB");
					exit(1);
			}
		} else {
			strcpy(name , argv[i]);
		}
	}
	if(flag == 0) {
		printf("@픻ʒ..΂炭҂B\r");
		if(search_strings(0xf000,"TOSHIBA")) {
			strcpy(filename , "J3100.FON");
			flag = TOSHIBA;
			puts("@͓J3100V[Ył傤B");
		} else if(search_strings(0xf000,"EPSON")) {
			strcpy(filename , "EPSON.FON");
			flag = EPSON;
			puts("@EPSON PC-286/386V[Ył傤B");
		} else if(search_strings(0xe800,"NEC")) {
			strcpy(filename , "NEC.FON");
			flag = NEC;
			puts("@NEC PC-9800V[Ył傤B");
		} else if(search_strings(0xf000,"OASY")) {
			if(search_strings(0xf000,"TOWN")) {
				strcpy(filename , "TOWNS.FON");
				flag = TOWNS;
				puts("@͕xm FM-TOWNSV[Ył傤B");
			} else {
				strcpy(filename , "FMR.FON");
				flag = FMR;
				puts("@͕xm FM-RV[Ył傤B");
			}
		} else {
			puts("@̔ʂł܂łB");
			puts("ȉ̃IvVčĎsĂB");
			usage();
			exit(1);
		}
	}
	if(name[0] != '\0') {
		strcpy(filename , name);
	}
	get_all_font(filename , flag , font_type);
}

usage()
{
	puts(" Usage :  getfont [option] [file_name]");
	puts(" option:");
	puts("     -j            .. J3100");
	puts("     -n            .. EPSON-PC or NEC-PC");
	puts("     -f            .. FM-R or FM-TOWNS");
	puts("                      ʏ͏LR@Ȃ玩ʂ܂");
	puts("     -a            .. ASCII");
	puts("     -h            .. ASCII+p");
	puts("     -1            .. ASCII+p+ꐅ");
	puts("     -s[0|1|2|3|4] .. ASCIItHgޑI");
	puts("                         J3100̏ꍇ0`4");
	puts("                         EPSON-PC or NEC-PC̏ꍇ0`1");
}

get_all_font(char *filename , int flag , int font_type)
{
	int fp;
	unsigned char *pt;
	unsigned char *write_buffer;
	unsigned char *zero_tmp;
	int high , low;
	int i;
	int size;
	int max = (font_type == JIS_1) ? 0x50 : 0x75;

	if((fp = open(filename , O_CREAT | O_TRUNC | O_BINARY | O_WRONLY , S_IREAD | S_IWRITE)) == -1){
		puts("t@CI[vłB");
		exit(1);
	}
	if((write_buffer = (unsigned char *)malloc(BUFFER_SIZE)) == NULL) {
		puts("mۂłB");
		exit(1);
	}
	if((zero_tmp = (unsigned char *)malloc(BUFFER_SIZE)) == NULL) {
		puts("mۂłB");
		exit(1);
	}
	memset(zero_tmp , 0 , BUFFER_SIZE);

	pt = write_buffer;
	/* ASCII font make */
	if(flag & TOSHIBA) {
		toshiba_get_ascii_font(write_buffer);
	} else {
		for(low = 0 ; low < 0x100 ; low++) {
			if(low == 0x5c) {
				memcpy(pt , bs_data , 16);
			} else {
				if (low == 0x7f) {
					get_ascii_font(0x5c , (unsigned char *)&font , flag);
				} else {
					get_ascii_font(low , (unsigned char *)&font , flag);
				}
				memcpy(pt , font.buffer , 16);
			}
			pt += 16;
		}
	}
	/* pJ^Ji & Ђ炪ȃZbg */
	hirakana_set(write_buffer);
	size = BUFFER_SIZE;
	if(font_type == ASCII) {
		size = BUFFER_SIZE / 2;
	}
	write(fp , write_buffer , size);

	if(font_type == JIS_1 || font_type == JIS_2) {
		/* JIS font make */
		for(high = 0x21 ; high < max ; high++) {
			printf("JIS %X21H`%X7eH܂łǂ݂Ă܂B\r",high,high);
			if(high == 0x28 && (flag & NEC)) {
				keisen(write_buffer , flag);
				write(fp , write_buffer , 32 * 32);
				write(fp , zero_tmp , 62 * 32);
			} else if(high >= 0x29 && high <= 0x2b && !(flag & TOSHIBA)) {
				write(fp , zero_tmp , SECTION_SIZE);
			} else {
				pt = write_buffer;
				for(low = 0x21 ; low < 0x7f ; low++) {
					get_kanji_font(high , low , (unsigned char *)&font , flag);
					memcpy(pt , font.buffer , 32);
					pt += 32;
				}
				write(fp , write_buffer , SECTION_SIZE);
			}
		}
	}
	close(fp);
	printf("tHgt@C(%s)쐬I܂B\n" , filename);
}

keisen(char *pt , int flag)
{
	int low;

	for(low = 0 ; low < 0x20 ; low++) {
		get_kanji_font(0x2c , jis_keisen[low] , (unsigned char *)&font , flag);
		memcpy(pt , font.buffer , 32);
		pt += 32;
	}
}

get_ascii_font(int code , unsigned char *font , int flag)
{
	union REGS r;
	struct SREGS s;

	if(flag & PC98) {
		if(font_style == 0 || code < 0x20
			|| code == 0x7c || code == 0x7e) {
			r.x.bx = FP_SEG(font);
			r.x.cx = FP_OFF(font);
			r.h.dh = 0x80;
			r.h.dl = code;
			r.h.ah = 0x14;
			int86(0x18 , &r , &r);
		} else {
			r.x.bx = FP_SEG(font);
			r.x.cx = FP_OFF(font);
			r.h.dh = 0x29;
			r.h.dl = code;
			r.h.ah = 0x14;
			int86(0x18 , &r , &r);
		}
	} else if(flag & FUJITSU) {
		s.ds = FP_SEG(font);
		r.x.di = FP_OFF(font+2);
		r.x.bx = code;
		r.h.dh = 8;
		r.h.dl = 16;
		r.h.ah = 0x07;
		int86x(0x91 , &r , &r , &s);
	}
}

toshiba_get_ascii_font(unsigned char *font_pt)
{
	union REGS r;
	struct SREGS s;

	char far *ascii_pt;
	char *pt;
	int i , low , add;
	unsigned int off , seg;

	r.x.ax = 0x1000;
	int86x(0x60 , &r , &r , &s);
	seg = s.es;
	off = r.x.bx;
	if(font_style == 1) {
		off = 0xb400;
		seg = 0xf000;
	} else if(font_style == 4) {
		off = 0xb400;
	}
	ascii_pt = MK_FP(seg , off);
	pt = font_pt;
	for(i = 0 ; i < BUFFER_SIZE ; i++) {
		*pt++ = *ascii_pt++;
	}
	if(font_style == 2 || font_style == 3) {
		add = (font_style == 2) ? 0 : 1;
		pt = font_pt+16*0x20;
		for(low = 0x20 ; low < 0x7f ; low++) {
			if(low != 0x5c) {
				get_kanji_font(0x20 , low , (unsigned char *)&font , TOSHIBA);
				for(i = 0 ; i < 16 ; i++) {
					*pt++ = font.buffer[i * 2 + add];
				}
			} else {
				pt += 16;
			}
		}
	}
	/* p */
	get_kanji_font(0x20 , 0x5c , (unsigned char *)&font , TOSHIBA);
	pt = font_pt + 16 * 0x7f;
	for(i = 0 ; i < 16 ; i++) {
		*pt++ = font.buffer[i*2];
	}
	/* pJi */
	pt = font_pt + 16 * 0xa1;
	for(low = 0x21 ; low < 0x60 ; low++) {
		get_kanji_font(0x29 , low , (unsigned char *)&font , TOSHIBA);
		for(i = 0 ; i < 16 ; i++) {
			*pt++ = font.buffer[i*2];
		}
	}
}

hirakana_set(unsigned char *font_pt)
{
	memcpy(font_pt + 0x86 * 16 , hira_data , 26 * 16);
	memcpy(font_pt + 0xe0 * 16 , hira_data + 26 * 16 , 30 * 16);
}


get_kanji_font(int high , int low, unsigned char *font , int flag)
{
	union REGS r;
	struct SREGS s;
	int i;
	unsigned int seg , off;
	unsigned char bank;

	if(flag & PC98) {
		r.x.bx = FP_SEG(font);
		r.x.cx = FP_OFF(font);
		r.h.dh = high;
		r.h.dl = low;
		r.h.ah = 0x14;
		int86(0x18 , &r , &r);
	} else if(flag & FUJITSU) {
		s.ds = FP_SEG(font);
		r.x.di = FP_OFF(font+2);
		r.h.bl = high;
		r.h.bh = low;
		r.h.dh = 16;
		r.h.dl = 16;
		r.h.ah = 0x07;
		int86x(0x91 , &r , &r , &s);
	} else if(flag & TOSHIBA) {
		r.x.ax = 0x0301;
		r.h.dh = high;
		r.h.dl = low;
		int86x(0x60 , &r , &r , &s);
		seg = s.es;
		off = r.x.si;
		bank = r.h.al;
		if(seg >= 0xe000 && seg <= 0xefff) {
			pokeb(seg , off , bank | 0x80);
		}
		font += 2;
		for(i = 0 ; i < 32 ; i++) {
			*font++ = peekb(seg , off);
			if(off == 0xffff) {
				off = 0;
				bank++;
				if(seg >= 0xe000 && seg <= 0xefff) {
					pokeb(seg , off , bank | 0x80);
				}
			} else {
				off++;
			}
		}
	}
}

int search_strings(unsigned int seg , char *sch)
{
	unsigned int off = 0;
	char first = *sch;
	char work[20];
	int len = strlen(sch);
	int flag = 1;
	long adr;

	while(flag) {
		if(toupper(first) == peekb(seg , off)) {
			if(!far_strncmpi((char far *)sch , MK_FP(seg , off) , len)) {
				return 1;
			}
		}
		if(off == 0xffff) {
			off = 0;
			seg += 0x1000;
			if(seg < 0x1000) {
				flag = 0;
			}
		} else {
			off++;
		}
	}
	return 0;
}

int far_strncmpi(char far *s1 , char far *s2 , int len)
{
	int i;

	for(i = 0 ; i < len ; i++) {
		if(toupper(*s1) != toupper(*s2)) {
			return 1;
		}
		s1++;
		s2++;
	}
	return 0;
}

